<template>
  <v-dialog v-model="dialogData" persistent max-width="600px">
    <v-form ref="form" v-model="valid" lazy-validation>
      <v-card>
        <v-card-title>
          <span v-if="userData.id" class="text-h5">Chỉnh sửa User</span>
          <span v-else class="text-h5">Thêm User</span>
        </v-card-title>
        <v-card-text>
          <v-container>
            <v-row>
              <v-col cols="12">
                <v-text-field
                  label="Tên"
                  outlined
                  dense
                  :rules="rules.name"
                  v-model="form.name"
                  @keydown.enter="onSave"
                ></v-text-field>
              </v-col>
              <v-col cols="12">
                <v-text-field
                  label="Email"
                  outlined
                  dense
                  :rules="rules.email"
                  v-model="form.email"
                  @keydown.enter="onSave"
                ></v-text-field>
              </v-col>
              <v-col cols="12">
                <v-text-field
                  type="password"
                  outlined
                  label="Mật khẩu"
                  autocomplete="nope"
                  prepend-inner-icon="mdi-key"
                  :rules="rules.password"
                  v-model="form.password"
                  @keydown.enter="onSave"
                ></v-text-field>
              </v-col>
              <v-col cols="12">
                <v-text-field
                  type="password"
                  outlined
                  label="Xác nhận"
                  autocomplete="nope"
                  prepend-inner-icon="mdi-key"
                  :rules="rules.passwordConfirmation"
                  v-model="form.passwordConfirmation"
                  @keydown.enter="onSave"
                ></v-text-field>
              </v-col>
              <v-col cols="12">
                <v-select
                  label="Nhóm"
                  dense
                  outlined
                  :items="groupRoleItems"
                  :rules="rules.groupRole"
                  v-model="form.groupRole"
                ></v-select>
              </v-col>
              <v-col cols="12">
                <v-checkbox
                  v-model="isActive"
                  label="Trạng thái"
                  :value="1"
                ></v-checkbox>
              </v-col>
            </v-row>
          </v-container>
        </v-card-text>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="blue-grey lighten-4" @click="onClose"> Hủy </v-btn>
          <v-btn color="red lighten-2 white--text" @click="onSave"> Lưu </v-btn>
        </v-card-actions>
      </v-card>
    </v-form>
  </v-dialog>
</template>

<script>
import userService from "../../../services/userService";

export default {
  props: {
    userData: {
      type: Object,
      required: false,
      default: {},
    },
    dialogData: {
      type: Boolean,
      required: true,
      default: false,
    },
  },
  data() {
    return {
      valid: false,
      groupRoleItems: ["Admin", "Reviewer", "Editor"],
      form: {
        name: "",
        email: "",
        password: "",
        passwordConfirmation: "",
        groupRole: "",
        isActive: 1,
      },
      rules: {
        name: [
          (v) => {
            if (!v) return "Tên không được trống.";
            if (!!v && v.length < 5) return "Tên phải lớn hơn 5 ký tự.";
            return true;
          },
        ],
        email: [
          (v) => {
            if (!v) return "Email không được trống.";
            if (!!v && !/.+@.+\..+/.test(v))
              return "Email không đúng định dạng.";
            return true;
          },
        ],
        password: [
          (v) => {
            if (this.userData.id) {
              if (!!v && v.length < 5) return "Mật khẩu ít nhất 5 ký tự.";
              if (!!v && !/(?=.*\d)(?=.*[a-z])(?=.*[A-Z]).{5,}/.test(v))
                return "Mật khẩu không bảo mật.";
            } else {
              if (!v) return "Mật khẩu không được trống.";
              if (v.length < 5) return "Mật khẩu ít nhất 5 ký tự.";
              if (!/(?=.*\d)(?=.*[a-z])(?=.*[A-Z]).{5,}/.test(v))
                return "Mật khẩu không bảo mật.";
            }
            return true;
          },
        ],
        passwordConfirmation: [
          (v) => {
            if (this.userData.id) {
              if (!!v && v !== this.form.password)
                return "Mật khẩu và xác nhận mật khẩu không chính xác.";
            } else {
              if (!v) return "Mật khẩu không được trống.";
              if (v !== this.form.password)
                return "Mật khẩu và xác nhận mật khẩu không chính xác.";
            }
            return true;
          },
        ],
        groupRole: [
          (v) => {
            if (!v) return "Nhóm không được trống.";
            return true;
          },
        ],
      },
    };
  },
  computed: {
    isActive: {
      get() {
        return this.form.isActive;
      },
      set(val) {
        this.form.isActive = Number(val);
      },
    },
  },
  watch: {
    userData(newVal, oldVal) {
      this.form = newVal;
    },
  },
  methods: {
    onSave() {
      const isValid = this.$refs.form.validate();
      if (!isValid) return false;

      this.$store.commit("loading", true);
      if (this.userData.id) {
        userService
          .update(this.userData.id, this.form)
          .then((response) => {
            this.$store.commit("loading", false);
            this.$store.commit("showMessageSuccess", "Cập nhật thành công");
            this.onClose();
            this.$emit("onReloadList");
          })
          .catch((error) => {
            let msgError = "";
            if (error.response.status === 422) {
              const dataErrors = error.response.data.errors;
              let errors = [];
              for (const [key, value] of Object.entries(dataErrors)) {
                errors.push(value);
              }
              msgError = errors.toString();
            } else {
              msgError = error.response.data.message;
            }
            this.$store.commit("loading", false);
            this.$store.commit("showMessageError", msgError);
          });
      } else {
        userService
          .add(this.form)
          .then((response) => {
            this.$store.commit("loading", false);
            this.$store.commit("showMessageSuccess", "Thêm thành công");
            this.onClose();
            this.$emit("onReloadList");
          })
          .catch((error) => {
            let msgError = "";
            if (error.response.status === 422) {
              const dataErrors = error.response.data.errors;
              let errors = [];
              for (const [key, value] of Object.entries(dataErrors)) {
                errors.push(value);
              }
              msgError = errors.toString();
            } else {
              msgError = error.response.data.message;
            }
            this.$store.commit("loading", false);
            this.$store.commit("showMessageError", msgError);
          });
      }
    },
    onClose() {
      this.form = {
        name: "",
        email: "",
        password: "",
        passwordConfirmation: "",
        groupRole: "",
        isActive: 1,
      };
      this.$refs.form.reset();
      this.$emit("onChangeDialogData", false);
    },
  },
  created() {
    this.form = this.userData;
  },
};
</script>
